Index: utils/CI/sette/sette.sh
===================================================================
--- utils/CI/sette/sette.sh	(revision 15030)
+++ utils/CI/sette/sette.sh	(revision 15159)
@@ -15,4 +15,5 @@
 export USING_EXTRA_HALO='yes'  # Default: yes => set nn_hls=2           ; use -e to set nn_hls=1
 export USING_COLLECTIVES='yes' # Default: yes => set nn_comm=2          ; use -C to set nn_comm=1
+export USING_NOGATHER='yes'    # Default: yes => set ln_nnogather=.true.; use -N to set ln_nnogather=.false.
 export USING_TILING='yes'      # Default: yes => set ln_tile=.true.     ; use -t to disable
                                #    Note: yes also ensures nn_hls=2 but -t will not alter nn_hls 
@@ -34,5 +35,5 @@
 # Parse command-line arguments
 if [ $# -gt 0 ]; then
-  while getopts n:x:v:g:cdrshTqQteiACFX option; do 
+  while getopts n:x:v:g:cdrshTqQteiACFNX option; do 
      case $option in
         c) export SETTE_CLEAN_CONFIGS='yes'
@@ -85,4 +86,7 @@
            echo "-C: nn_comm will be set to 1"
            echo "";;
+        N) export USING_NOGATHER='no'
+           echo "-N: ln_nnogather will be set to false"
+           echo "";;
         q) export USING_QCO='no'
            echo "-q: key_qco and key_linssh will NOT be activated"
@@ -107,4 +111,5 @@
                echo '-i set ln_icebergs false (default: true)'
                echo '-C set nn_comm=1 (default: nn_comm=2 ==> use MPI3 collective comms)'
+               echo '-N set ln_nnogather false for ORCA2 configurations (default: true)'
                echo '-q to remove the key_qco key (default: added)'
                echo '-X to remove the key_xios key (default: added)'
@@ -207,4 +212,5 @@
 printf "%-33s : %s\n" USING_TILING $USING_TILING
 printf "%-33s : %s\n" USING_COLLECTIVES $USING_COLLECTIVES
+printf "%-33s : %s\n" USING_NOGATHER $USING_NOGATHER
 printf "%-33s : %s\n" USING_QCO $USING_QCO
 printf "%-33s : %s\n" USING_LOOP_FUSION $USING_LOOP_FUSION
Index: utils/CI/sette/sette_eval.sh
===================================================================
--- utils/CI/sette/sette_eval.sh	(revision 15030)
+++ utils/CI/sette/sette_eval.sh	(revision 15159)
@@ -1,3 +1,3 @@
-#!/bin/bash -f
+#!/bin/bash 
 # set -vx
 # simple SETTE result evaluator
@@ -14,4 +14,20 @@
 nrmiss=0
 nvmiss=0
+TESTD_ROOT=LONG
+
+function get_testd() {
+  sroot=$1/${TESTD_ROOT}
+  ls -1d "$sroot"* &> /dev/null
+  if [ $? -eq 0 ] ; then
+   TESTD=`ls -1d "$sroot"* | head -1l`
+   TESTD=`basename $TESTD`
+   if [ ! -d $1/$TESTD ] ; then
+     echo "TEST directory not found with rootname: "$TESTD_ROOT
+     exit
+   fi
+  else
+   TESTD=$TESTD_ROOT
+  fi
+}
 
 function get_dorv() {
@@ -72,8 +88,13 @@
 #
   if [ -d $vdir/$mach/$dorv/$nam ]; then
-    f1s=$vdir/$mach/$dorv/$nam/LONG/run.stat
-    f1t=$vdir/$mach/$dorv/$nam/LONG/tracer.stat
-    f2s=$vdirref/$mach/$dorvref/$nam/LONG/run.stat
-    f2t=$vdirref/$mach/$dorvref/$nam/LONG/tracer.stat
+    get_testd $vdir/$mach/$dorv/$nam
+    if  [ ! -d $vdir/$mach/$dorv/$nam/$TESTD ] ; then
+      printf "%-20s %s (%s)\n" $nam " not tested" $TESTD;
+      return;
+    fi
+    f1s=$vdir/$mach/$dorv/$nam/$TESTD/run.stat
+    f1t=$vdir/$mach/$dorv/$nam/$TESTD/tracer.stat
+    f2s=$vdirref/$mach/$dorvref/$nam/$TESTD/run.stat
+    f2t=$vdirref/$mach/$dorvref/$nam/$TESTD/tracer.stat
     if  [ ! -f $f1s ] && [ ! -f $f1t ] ; then
       printf "%-20s %s\n" $nam " incomplete test";
@@ -91,10 +112,10 @@
       if [ $? == 0 ]; then
         if [ $silent == 0 ]; then
-          printf "%-20s %s %s\n" $nam  " run.stat    files are identical "
+          printf "%-20s %s (%s)\n" $nam  " run.stat    files are identical " $TESTD
         fi
       else
         get_ktdiff $f1s $f2s
         if [ $silent == 0 ]; then
-         printf "%-20s %s %s %-5s %s\n" $nam  " run.stat    files are DIFFERENT (results are different after " $ktdiff " time steps)"
+         printf "%-20s %s %s %-5s (%s)\n" $nam  " run.stat    files are DIFFERENT (results are different after " $ktdiff " time steps) " $TESTD
         else
          errcnt=$(( $errcnt + 1 ))
@@ -109,10 +130,10 @@
       if [ $? == 0 ]; then
         if [ $silent == 0 ]; then          
-          printf "%-20s %s %s\n" $nam  " tracer.stat files are identical "
+          printf "%-20s %s (%s)\n" $nam  " tracer.stat files are identical " $TESTD
         fi
       else
         get_ktdiff2 $f1t $f2t
         if [ $silent == 0 ]; then          
-         printf "%-20s %s %s %-5s %s\n" $nam  " tracer.stat files are DIFFERENT (results are different after " $ktdiff " time steps) "
+         printf "%-20s %s %s %-5s (%s)\n" $nam  " tracer.stat files are DIFFERENT (results are different after " $ktdiff " time steps) " $TESTD
         else
          errcnt=$(( $errcnt + 1 ))
@@ -139,5 +160,5 @@
 # overwrite revision (later) or compiler
   if [ $# -gt 0 ]; then
-    while getopts r:R:c:v:V:qh option; do 
+    while getopts r:R:c:v:V:T:qh option; do 
        case $option in
           c) mach=$OPTARG;;
@@ -153,4 +174,5 @@
              fi
              ;;
+          T) TESTD_ROOT=$OPTARG;;
           h | *) echo ''
                  echo 'sette_eval.sh : ' 
@@ -162,4 +184,6 @@
                  echo ' -R REFERENCE REVISION_number :'
                  echo '     compare sette results against the specified revision (use to over-ride value set in param.cfg)'
+                 echo ' -T test_rootname :'
+                 echo '     root of test name to be checked. Valid choices ares: LONG, SHORT, REPRO. [default: LONG]'
                  echo ' -v sub_dir :'
                  echo '     validation sub-directory below NEMO_VALIDATION_DIR'
@@ -252,5 +276,5 @@
       echo ''
      fi
-     checklist=(GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 ORCA2_SAS_ICE AGRIF_DEMO WED025 ISOMIP+ VORTEX ICE_AGRIF OVERFLOW LOCK_EXCHANGE SWG)
+     checklist=(GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 ORCA2_SAS_ICE ORCA2_ICE_OBS AGRIF_DEMO WED025 ISOMIP+ VORTEX ICE_AGRIF OVERFLOW LOCK_EXCHANGE SWG) 
      for repro_test in ${checklist[@]}
      do
Index: utils/CI/sette/sette_list_avail_rev.sh
===================================================================
--- utils/CI/sette/sette_list_avail_rev.sh	(revision 15030)
+++ utils/CI/sette/sette_list_avail_rev.sh	(revision 15159)
@@ -78,5 +78,5 @@
  echo " Availability for each config.: "
  echo -n " ------------------------------"
- for CONFIG in GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 ORCA2_SAS_ICE AGRIF_DEMO SWG ISOMIP+ OVERFLOW LOCK_EXCHANGE VORTEX ICE_AGRIF 
+ for CONFIG in GYRE_PISCES ORCA2_ICE_PISCES ORCA2_OFF_PISCES AMM12 WED025 ORCA2_ICE_OBS ORCA2_SAS_ICE AGRIF_DEMO SWG ISOMIP+ OVERFLOW LOCK_EXCHANGE VORTEX ICE_AGRIF 
  do
     DIR=${NEMO_VALID}/${COMPILER}/
Index: utils/CI/sette/sette_reference-configurations.sh
===================================================================
--- utils/CI/sette/sette_reference-configurations.sh	(revision 15030)
+++ utils/CI/sette/sette_reference-configurations.sh	(revision 15159)
@@ -326,4 +326,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     # for debugging purposes set_namelist namelist_cfg rn_test_box -180.0, 180.0, -90.0, -55.0
@@ -370,4 +371,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     # for debugging purposes set_namelist namelist_cfg rn_test_box -180.0, 180.0, -90.0, -55.0
@@ -436,4 +438,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     # for debugging purposes set_namelist namelist_cfg rn_test_box -180.0, 180.0, -90.0, -55.0
@@ -480,4 +483,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     # for debugging purposes set_namelist namelist_cfg rn_test_box -180.0, 180.0, -90.0, -55.0
@@ -1023,4 +1027,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     set_xio_using_server iodef.xml ${USING_MPMD}
@@ -1071,4 +1076,5 @@
     set_namelist_opt namelist_cfg nn_hls ${USING_EXTRA_HALO} 2 1
     set_namelist_opt namelist_cfg nn_comm ${USING_COLLECTIVES} 2 1
+    set_namelist_opt namelist_cfg ln_nnogather ${USING_NOGATHER} .true. .false.
     set_namelist_opt namelist_cfg ln_tile ${USING_TILING} .true. .false.
     set_xio_using_server iodef.xml ${USING_MPMD}