Index: NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/apdx_triads.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/apdx_triads.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/apdx_triads.tex	(revision 15264)
@@ -1,13 +1,3 @@
 \documentclass[../main/NEMO_manual]{subfiles}
-
-%% Local cmds
-\newcommand{\rML}[1][i]{\ensuremath{_{\mathrm{ML}\,#1}}}
-\newcommand{\rMLt}[1][i]{\tilde{r}_{\mathrm{ML}\,#1}}
-%% Move to ../../global/new_cmds.tex to avoid error with \listoffigures
-%\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}
-\newcommand{\triadd}[5]{\ensuremath{{}_{#1}^{#2}{\mathbb{#3}}_{#4}^{\,#5}}}
-\newcommand{\triadt}[5]{\ensuremath{{}_{#1}^{#2}{\tilde{\mathbb{#3}}}_{#4}^{\,#5}}}
-\newcommand{\rtriad}[2][]{\ensuremath{\triad[#1]{i}{k}{#2}{i_p}{k_p}}}
-\newcommand{\rtriadt}[1]{\ensuremath{\triadt{i}{k}{#1}{i_p}{k_p}}}
 
 \begin{document}
Index: NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/chap_ZDF.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/chap_ZDF.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/NEMO/subfiles/chap_ZDF.tex	(revision 15264)
@@ -1,6 +1,3 @@
 \documentclass[../main/NEMO_manual]{subfiles}
-
-%% Custom aliases
-\newcommand{\cf}{\ensuremath{C\kern-0.14em f}}
 
 \begin{document}
Index: NEMO/branches/2020/ticket2487/doc/latex/TOP/subfiles/model_description.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/TOP/subfiles/model_description.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/TOP/subfiles/model_description.tex	(revision 15264)
@@ -1,12 +1,3 @@
 \documentclass[../main/TOP_manual]{subfiles}
-
-\newcommand{\cd}{\mathrm{CO_2}}
-\newcommand{\Ct}{\mathrm{C_T}}
-\newcommand{\pacd}{\mathrm{p^a_{CO_2}}}
-\newcommand{\cq}{\mathrm{^{14}C}}
-\newcommand{\Dcq}{\Delta ^{14}\mathrm{C}}
-\newcommand{\Rq}{\mathrm{^{14}{R}}}
-\newcommand{\CODE}[1]{\textsc{#1}}
-%\newcommand{\CODE}[1]{\textcolor{black}{\textsc{#1}}\xspace}
 
 \begin{document}
Index: NEMO/branches/2020/ticket2487/doc/latex/global/document.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/global/document.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/global/document.tex	(revision 15264)
@@ -6,4 +6,5 @@
 %% NEMO release version
 \def \version{4.0-HEAD}
+\def \date{Month YYYY}
 
 %% Preamble
Index: NEMO/branches/2020/ticket2487/doc/latex/global/frontpage.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/global/frontpage.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/global/frontpage.tex	(revision 15264)
@@ -32,6 +32,6 @@
   \begin{center}
     \LARGE Version \version\ -\ \today \\
-%    \medskip
-%    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
+    \medskip
+    \href{http://doi.org/10.5281/zenodo.\zid}{ \includegraphics{badges/zenodo.\zid} }
   \end{center}
 
Index: NEMO/branches/2020/ticket2487/doc/latex/global/info_page.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/global/info_page.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/global/info_page.tex	(revision 15264)
@@ -72,5 +72,5 @@
   \hfill
   \begin{minipage}[c]{0.25\textwidth}
-    \href{http://www.cmc.ipsl.fr}{\includegraphics[width=\textwidth]{logos/IPSL_upright}}
+    \href{http://www.cmc.ipsl.fr}{\includegraphics[width=\textwidth]{logos/IPSL_master}}
   \end{minipage}
 \end{figure}
Index: NEMO/branches/2020/ticket2487/doc/latex/global/new_cmds.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/global/new_cmds.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/global/new_cmds.tex	(revision 15264)
@@ -58,6 +58,20 @@
 \newcommand{\orcid}[1]{\href{http://orcid.org/#1}{\textcolor{orcidcolor}\aiOrcidSquare}}
 
-%% Workaround for \listoffigures
-\DeclareRobustCommand{\triad}[6][]{\ensuremath{ {}_{#2}^{#3} { \mathbb{#4}_{#1} }_{#5}^{\,#6} }}
+%% Custom aliases
+\newcommand{\cf}{\ensuremath{C\kern-0.14em f}}
+\newcommand{\rML}[1][i]{\ensuremath{_{\mathrm{ML}\,#1}}}
+\newcommand{\rMLt}[1][i]{\tilde{r}_{\mathrm{ML}\,#1}}
+\newcommand{\triad}[6][]{\ensuremath{{}_{#2}^{#3}{\mathbb{#4}_{#1}}_{#5}^{\,#6}}}
+\newcommand{\triadd}[5]{\ensuremath{{}_{#1}^{#2}{\mathbb{#3}}_{#4}^{\,#5}}}
+\newcommand{\triadt}[5]{\ensuremath{{}_{#1}^{#2}{\tilde{\mathbb{#3}}}_{#4}^{\,#5}}}
+\newcommand{\rtriad}[2][]{\ensuremath{\triad[#1]{i}{k}{#2}{i_p}{k_p}}}
+\newcommand{\rtriadt}[1]{\ensuremath{\triadt{i}{k}{#1}{i_p}{k_p}}}
+\newcommand{\cd}{\mathrm{CO_2}}
+\newcommand{\Ct}{\mathrm{C_T}}
+\newcommand{\pacd}{\mathrm{p^a_{CO_2}}}
+\newcommand{\cq}{\mathrm{^{14}C}}
+\newcommand{\Dcq}{\Delta ^{14}\mathrm{C}}
+\newcommand{\Rq}{\mathrm{^{14}{R}}}
+\newcommand{\CODE}[1]{\textsc{#1}}
 
 %% New command for ToC
Index: NEMO/branches/2020/ticket2487/doc/latex/global/styles.tex
===================================================================
--- NEMO/branches/2020/ticket2487/doc/latex/global/styles.tex	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/latex/global/styles.tex	(revision 15264)
@@ -72,14 +72,3 @@
 }
 
-%% Temporary fix
-\def\set@curr@file#1{%
-  \begingroup
-    \escapechar\m@ne
-    \xdef\@curr@file{\expandafter\string\csname #1\endcsname}%
-  \endgroup
-}
-\def\quote@name#1{"\quote@@name#1\@gobble""}
-\def\quote@@name#1"{#1\quote@@name}
-\def\unquote@name#1{\quote@@name#1\@gobble"}
-
 \makeatother
Index: NEMO/branches/2020/ticket2487/doc/manual_build.sh
===================================================================
--- NEMO/branches/2020/ticket2487/doc/manual_build.sh	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/manual_build.sh	(revision 15264)
@@ -38,5 +38,5 @@
 for model in $models; do
     echo $model
-#    clean $model
+    clean $model
     build $model
     printf "\t¤ End of building run\n"
Index: NEMO/branches/2020/ticket2487/doc/namelists/nambdy_dta
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/nambdy_dta	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/nambdy_dta	(revision 15264)
@@ -29,4 +29,5 @@
    bn_aip      = 'NOT USED'              ,         24.       , 'siapnd'  ,    .true.   , .false.,  'daily'  ,    ''            ,   ''     ,     ''
    bn_hip      = 'NOT USED'              ,         24.       , 'sihpnd'  ,    .true.   , .false.,  'daily'  ,    ''            ,   ''     ,     ''
+   bn_hil      = 'NOT USED'              ,         24.       , 'sihlid'  ,    .true.   , .false.,  'daily'  ,    ''            ,   ''     ,     ''
    ! if bn_t_i etc are "not used", then define arbitrary temperatures and salinity and ponds
    rn_ice_tem  = 270.         !  arbitrary temperature               of incoming sea ice
@@ -35,3 +36,4 @@
    rn_ice_apnd = 0.2          !       --   pond fraction = a_ip/a_i            --
    rn_ice_hpnd = 0.05         !       --   pond depth                          --
+   rn_ice_hlid = 0.0          !       --   pond lid depth                      --
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdia
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdia	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdia	(revision 15264)
@@ -8,5 +8,5 @@
    ln_icediahsb     = .false.         !  output the heat, mass & salt budgets (T) or not (F)
    ln_icectl        = .false.         !  ice points output for debug (T or F)
-   iiceprt          =  10             !  i-index for debug
-   jiceprt          =  10             !  j-index for debug
+      iiceprt       =  10             !     i-index for debug
+      jiceprt       =  10             !     j-index for debug
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdrg
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdrg	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdrg	(revision 15264)
@@ -2,5 +2,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_OFF      = .false.   !  free-slip       : Cd = 0                  (F => fill namdrg_bot
+   ln_drg_OFF  = .false.   !  free-slip       : Cd = 0                  (F => fill namdrg_bot
    ln_lin      = .false.   !      linear  drag: Cd = Cd0 Uc0                   &   namdrg_top)
    ln_non_lin  = .false.   !  non-linear  drag: Cd = Cd0 |U|
@@ -8,3 +8,4 @@
    !
    ln_drgimp   = .true.    !  implicit top/bottom friction flag
+      ln_drgice_imp = .false. ! implicit ice-ocean drag
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdrg_bot
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdrg_bot	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdrg_bot	(revision 15264)
@@ -1,4 +1,4 @@
 !-----------------------------------------------------------------------
-&namdrg_bot    !   BOTTOM friction                                      (ln_OFF =F)
+&namdrg_bot    !   BOTTOM friction                                      (ln_drg_OFF =F)
 !-----------------------------------------------------------------------
    rn_Cd0      =  1.e-3    !  drag coefficient [-]
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdrg_top
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdrg_top	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdrg_top	(revision 15264)
@@ -1,4 +1,4 @@
 !-----------------------------------------------------------------------
-&namdrg_top    !   TOP friction                                         (ln_OFF =F & ln_isfcav=T)
+&namdrg_top    !   TOP friction                                         (ln_drg_OFF =F & ln_isfcav=T)
 !-----------------------------------------------------------------------
    rn_Cd0      =  1.e-3    !  drag coefficient [-]
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdyn
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdyn	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdyn	(revision 15264)
@@ -10,8 +10,8 @@
    rn_ishlat        =   2.            !  lbc : free slip (0) ; partial slip (0-2) ; no slip (2) ; strong slip (>2)
    ln_landfast_L16  = .false.         !  landfast: parameterization from Lemieux 2016
-      rn_depfra     =   0.125         !        fraction of ocean depth that ice must reach to initiate landfast
+      rn_lf_depfra  =   0.125         !        fraction of ocean depth that ice must reach to initiate landfast
                                       !          recommended range: [0.1 ; 0.25]
-      rn_icebfr     =  15.            !        maximum bottom stress per unit volume [N/m3]
-      rn_lfrelax    =   1.e-5         !        relaxation time scale to reach static friction [s-1]
-      rn_tensile    =   0.05          !        isotropic tensile strength [0-0.5??]
+      rn_lf_bfr     =  15.            !        maximum bottom stress per unit volume [N/m3]
+      rn_lf_relax   =   1.e-5         !        relaxation time scale to reach static friction [s-1]
+      rn_lf_tensile =   0.05          !        isotropic tensile strength [0-0.5??]
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namdyn_rhg
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namdyn_rhg	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namdyn_rhg	(revision 15264)
@@ -9,3 +9,4 @@
       rn_relast     =   0.333         !     ratio of elastic timescale to ice time step: Telast = dt_ice * rn_relast 
                                       !        advised value: 1/3 (rn_nevp=120) or 1/9 (rn_nevp=300)
+   ln_rhg_chkcvg    = .false.         !  check convergence of rheology (outputs: file ice_cvg.nc & variable uice_cvg)
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namini
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namini	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namini	(revision 15264)
@@ -3,5 +3,7 @@
 !------------------------------------------------------------------------------
    ln_iceini        = .true.          !  activate ice initialization (T) or not (F)
-   ln_iceini_file   = .false.         !  netcdf file provided for initialization (T) or not (F)
+   nn_iceini_file   =   0             !     0 = Initialise sea ice based on SSTs
+                                      !     1 = Initialise sea ice from single category netcdf file
+                                      !     2 = Initialise sea ice from multi category restart file
    rn_thres_sst     =   2.0           !  max temp. above Tfreeze with initial ice = (sst - tfreeze)
    rn_hti_ini_n     =   3.0           !  initial ice thickness       (m), North
@@ -23,5 +25,7 @@
    rn_hpd_ini_n     =   0.05          !  initial pond depth          (m), North
    rn_hpd_ini_s     =   0.05          !        "            "             South
-   ! -- for ln_iceini_file = T
+   rn_hld_ini_n     =   0.0           !  initial pond lid depth      (m), North
+   rn_hld_ini_s     =   0.0           !        "            "             South
+   ! -- for nn_iceini_file = 1
    sn_hti = 'Ice_initialization'    , -12 ,'hti'   ,  .false.  , .true., 'yearly'  , '' , '', ''
    sn_hts = 'Ice_initialization'    , -12 ,'hts'   ,  .false.  , .true., 'yearly'  , '' , '', ''
@@ -34,4 +38,5 @@
    sn_apd = 'NOT USED'              , -12 ,'apd'   ,  .false.  , .true., 'yearly'  , '' , '', ''
    sn_hpd = 'NOT USED'              , -12 ,'hpd'   ,  .false.  , .true., 'yearly'  , '' , '', ''
+   sn_hld = 'NOT USED'              , -12 ,'hld'   ,  .false.  , .true., 'yearly'  , '' , '', ''
    cn_dir='./'
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namsbc_blk
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namsbc_blk	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namsbc_blk	(revision 15264)
@@ -31,4 +31,5 @@
    sn_snow     = 'ncar_precip.15JUNE2009_fill',   -1.        , 'SNOW'    ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
    sn_slp      = 'slp.15JUNE2009_fill'        ,    6.        , 'SLP'     ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
+   sn_cc       = 'NOT USED'                   ,   24         , 'CC'      ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
    sn_tdif     = 'taudif_core'                ,   24         , 'taudif'  ,   .false.   , .true. , 'yearly'  , 'weights_core_orca2_bilinear_noc.nc' , ''       , ''
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namsbc_cpl
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namsbc_cpl	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namsbc_cpl	(revision 15264)
@@ -2,9 +2,9 @@
 &namsbc_cpl    !   coupled ocean/atmosphere model                       ("key_oasis3")
 !-----------------------------------------------------------------------
-   nn_cplmodel   =     1   !  Maximum number of models to/from which NEMO is potentially sending/receiving data
-   ln_usecplmask = .false. !  use a coupling mask file to merge data received from several models
-   !                       !   -> file cplmask.nc with the float variable called cplmask (jpi,jpj,nn_cplmodel)
-   nn_cats_cpl   =     5   !  Number of sea ice categories over which coupling is to be carried out (if not 1)
-
+   nn_cplmodel       =     1   !  Maximum number of models to/from which NEMO is potentially sending/receiving data
+   ln_usecplmask     = .false. !  use a coupling mask file to merge data received from several models
+   !                           !   -> file cplmask.nc with the float variable called cplmask (jpi,jpj,nn_cplmodel)
+   ln_scale_ice_flux = .false. !  use ice fluxes that are already "ice weighted" ( i.e. multiplied ice concentration)
+   nn_cats_cpl       =     5   !  Number of sea ice categories over which coupling is to be carried out (if not 1)
    !_____________!__________________________!____________!_____________!______________________!________!
    !             !        description       !  multiple  !    vector   !       vector         ! vector !
Index: NEMO/branches/2020/ticket2487/doc/namelists/namthd
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namthd	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namthd	(revision 15264)
@@ -6,3 +6,5 @@
    ln_icedO         = .true.          !  activate ice growth in open-water (T) or not (F)
    ln_icedS         = .true.          !  activate brine drainage (T) or not (F)
+   !                                   
+   ln_leadhfx       = .true.          !  heat in the leads is used to melt sea-ice before warming the ocean
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namthd_pnd
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namthd_pnd	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namthd_pnd	(revision 15264)
@@ -2,9 +2,12 @@
 &namthd_pnd     !   Melt ponds
 !------------------------------------------------------------------------------
-   ln_pnd           = .false.         !  activate melt ponds or not
-     ln_pnd_H12     = .false.         !  activate evolutive melt ponds (from Holland et al 2012)
-     ln_pnd_CST     = .false.         !  activate constant  melt ponds
-       rn_apnd      =   0.2           !     prescribed pond fraction, at Tsu=0 degC
-       rn_hpnd      =   0.05          !     prescribed pond depth,    at Tsu=0 degC
-     ln_pnd_alb     = .false.         !  melt ponds affect albedo or not
+   ln_pnd            = .false.        !  activate melt ponds or not
+      ln_pnd_LEV     = .false.        !  level ice melt ponds (from Flocco et al 2007,2010 & Holland et al 2012)
+         rn_apnd_min =   0.15         !     minimum ice fraction that contributes to melt pond. range: 0.0 -- 0.15 ??
+         rn_apnd_max =   0.85         !     maximum ice fraction that contributes to melt pond. range: 0.7 -- 0.85 ??
+      ln_pnd_CST     = .false.        !  constant  melt ponds
+         rn_apnd     =   0.2          !     prescribed pond fraction, at Tsu=0 degC
+         rn_hpnd     =   0.05         !     prescribed pond depth,    at Tsu=0 degC
+      ln_pnd_lids    = .true.         !  frozen lids on top of the ponds (only for ln_pnd_LEV)
+      ln_pnd_alb     = .true.         !  effect of melt ponds on ice albedo
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namthd_zdf
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namthd_zdf	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namthd_zdf	(revision 15264)
@@ -7,4 +7,8 @@
    rn_cnd_s         =   0.31          !  thermal conductivity of the snow (0.31 W/m/K, Maykut and Untersteiner, 1971)
                                       !     Obs: 0.1-0.5 (Lecomte et al, JAMES 2013)
-   rn_kappa_i       =   1.0           !  radiation attenuation coefficient in sea ice [1/m]
+   rn_kappa_i       =   1.0           !  radiation attenuation coefficient in sea ice                     [1/m]
+   rn_kappa_s       =  10.0           !  nn_qtrice = 0: radiation attenuation coefficient in snow         [1/m]
+   rn_kappa_smlt    =   7.0           !  nn_qtrice = 1: radiation attenuation coefficient in melting snow [1/m]
+   rn_kappa_sdry    =  10.0           !                 radiation attenuation coefficient in dry snow     [1/m]
+   ln_zdf_chkcvg    = .false.         !  check convergence of heat diffusion scheme (output variable: tice_cvg)
 /
Index: NEMO/branches/2020/ticket2487/doc/namelists/namzdf_gls
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namzdf_gls	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namzdf_gls	(revision 15264)
@@ -13,4 +13,9 @@
    nn_z0_met     =     2   !  Method for surface roughness computation (0/1/2/3)
    !                             ! =3 requires ln_wave=T
+   nn_z0_ice     =   1     !  attenutaion of surface wave breaking under ice
+   !                       !           = 0 no impact of ice cover
+   !                       !           = 1 roughness uses rn_hsri and is weigthed by 1-TANH(10*fr_i)
+   !                       !           = 2 roughness uses rn_hsri and is weighted by 1-fr_i
+   !                       !           = 3 roughness uses rn_hsri and is weighted by 1-MIN(1,4*fr_i)
    nn_bc_surf    =     1   !  surface condition (0/1=Dir/Neum)
    nn_bc_bot     =     1   !  bottom condition (0/1=Dir/Neum)
Index: NEMO/branches/2020/ticket2487/doc/namelists/namzdf_tke
===================================================================
--- NEMO/branches/2020/ticket2487/doc/namelists/namzdf_tke	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/namelists/namzdf_tke	(revision 15264)
@@ -15,5 +15,4 @@
    ln_mxl0     = .true.    !  surface mixing length scale = F(wind stress) (T) or not (F)
    rn_mxl0     =   0.04    !  surface  buoyancy lenght scale minimum value
-   ln_drg      = .false.   !  top/bottom friction added as boundary condition of TKE
    ln_lc       = .true.    !  Langmuir cell parameterisation (Axell 2002)
       rn_lc       =   0.15    !  coef. associated to Langmuir cells
@@ -26,4 +25,8 @@
                               !        = 0  constant 10 m length scale
                               !        = 1  0.5m at the equator to 30m poleward of 40 degrees
-      rn_eice     =   4       !  below sea ice: =0 ON ; =4 OFF when ice fraction > 1/4   
+   nn_eice     =   1       !  attenutaion of langmuir & surface wave breaking under ice
+   !                       !           = 0 no impact of ice cover on langmuir & surface wave breaking
+   !                       !           = 1 weigthed by 1-TANH(10*fr_i)
+   !                       !           = 2 weighted by 1-fr_i
+   !                       !           = 3 weighted by 1-MIN(1,4*fr_i)
 /
Index: NEMO/branches/2020/ticket2487/doc/rst/requirements.txt
===================================================================
--- NEMO/branches/2020/ticket2487/doc/rst/requirements.txt	(revision 15264)
+++ NEMO/branches/2020/ticket2487/doc/rst/requirements.txt	(revision 15264)
@@ -0,0 +1,27 @@
+alabaster==0.7.12
+Babel==2.9.0
+certifi==2020.12.5
+chardet==4.0.0
+docutils==0.16
+idna==2.10
+imagesize==1.2.0
+Jinja2==2.11.3
+latexcodec==2.0.1
+MarkupSafe==1.1.1
+oset==0.1.3
+packaging==20.9
+pybtex==0.24.0
+pybtex-docutils==0.2.2
+Pygments==2.5.2
+pyparsing==2.4.7
+pytz==2021.1
+PyYAML==5.4.1
+requests==2.25.1
+six==1.15.0
+snowballstemmer==2.1.0
+Sphinx==1.8.5
+sphinx-rtd-theme==0.5.1
+sphinxcontrib-bibtex==0.4.2
+sphinxcontrib-websupport==1.1.2
+typing==3.7.4.3
+urllib3==1.26.3
Index: NEMO/branches/2020/ticket2487/doc/rst/source/conf.py
===================================================================
--- NEMO/branches/2020/ticket2487/doc/rst/source/conf.py	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/rst/source/conf.py	(revision 15264)
@@ -43,5 +43,5 @@
 # General information about the project.
 project = u'NEMO'
-copyright = u'2019, NEMO Consortium'
+copyright = u'2020, NEMO Consortium'
 
 # The version info for the project you're documenting, acts as replacement for
@@ -246,7 +246,5 @@
 
 # Timestamping
-import datetime
-year = datetime.date.today().year
-copyright = '2008-' + str( year ) + ', NEMO Consortium'
+copyright = '2008-YYYY, NEMO Consortium'
 
 # Link aliases
@@ -279,2 +277,5 @@
 # Default language to highlight set to fortran
 highlight_language = 'fortran'
+
+# Extra setting for sphinxcontrib.bibtex upgrade to 2.X.X branche
+bibtex_bibfiles = ['cfgs.bib', 'ref.bib', 'tests.bib', 'zooms.bib']
Index: NEMO/branches/2020/ticket2487/doc/rst/source/guide.rst
===================================================================
--- NEMO/branches/2020/ticket2487/doc/rst/source/guide.rst	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/rst/source/guide.rst	(revision 15264)
@@ -66,11 +66,5 @@
 
 :Release:  |release|
-
-.. only:: draft
-
-   .. Only on draft
-
-   :*Date*:     |today|
-   :*SVN rev*:  |revision|
+:SVN rev:  |revision|
 
 .. include:: readme.rst
Index: NEMO/branches/2020/ticket2487/doc/tools/check_pkg.py
===================================================================
--- NEMO/branches/2020/ticket2487/doc/tools/check_pkg.py	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/tools/check_pkg.py	(revision 15264)
@@ -1,3 +1,3 @@
-#!/usr/bin/env python
+#!/usr/bin/env python2
 
 import sys, importlib
Index: NEMO/branches/2020/ticket2487/doc/tools/shr_func.sh
===================================================================
--- NEMO/branches/2020/ticket2487/doc/tools/shr_func.sh	(revision 13171)
+++ NEMO/branches/2020/ticket2487/doc/tools/shr_func.sh	(revision 15264)
@@ -11,5 +11,5 @@
     printf "\t¤ Generation of the PDF format\n"
     latexmk -r  ./latex/global/latexmk.pl -pdfxe ./latex/$1/main/$1_manual \
-#	1> /dev/null
+	1> /dev/null
     [ -f ./latex/$1/build/$1_manual.pdf ] && mv ./latex/$1/build/$1_manual.pdf .
     echo